# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from robotino_msgs/NorthStarReadings.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import genpy

class NorthStarReadings(genpy.Message):
  _md5sum = "b8db44cc88a378f5282e8add1661d1e7"
  _type = "robotino_msgs/NorthStarReadings"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """time stamp
uint32 seq
uint32 roomId
uint32 numSpotsVisible
geometry_msgs/Pose pose
uint32 magSpot0
uint32 magSpot1
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['stamp','seq','roomId','numSpotsVisible','pose','magSpot0','magSpot1']
  _slot_types = ['time','uint32','uint32','uint32','geometry_msgs/Pose','uint32','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,seq,roomId,numSpotsVisible,pose,magSpot0,magSpot1

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NorthStarReadings, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.seq is None:
        self.seq = 0
      if self.roomId is None:
        self.roomId = 0
      if self.numSpotsVisible is None:
        self.numSpotsVisible = 0
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.magSpot0 is None:
        self.magSpot0 = 0
      if self.magSpot1 is None:
        self.magSpot1 = 0
    else:
      self.stamp = genpy.Time()
      self.seq = 0
      self.roomId = 0
      self.numSpotsVisible = 0
      self.pose = geometry_msgs.msg.Pose()
      self.magSpot0 = 0
      self.magSpot1 = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_5I7d2I.pack(_x.stamp.secs, _x.stamp.nsecs, _x.seq, _x.roomId, _x.numSpotsVisible, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.magSpot0, _x.magSpot1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 84
      (_x.stamp.secs, _x.stamp.nsecs, _x.seq, _x.roomId, _x.numSpotsVisible, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.magSpot0, _x.magSpot1,) = _struct_5I7d2I.unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_5I7d2I.pack(_x.stamp.secs, _x.stamp.nsecs, _x.seq, _x.roomId, _x.numSpotsVisible, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.magSpot0, _x.magSpot1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 84
      (_x.stamp.secs, _x.stamp.nsecs, _x.seq, _x.roomId, _x.numSpotsVisible, _x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w, _x.magSpot0, _x.magSpot1,) = _struct_5I7d2I.unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_5I7d2I = struct.Struct("<5I7d2I")
